
/* GENERATED CODE... DO NOT EDIT */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Copyright (C) 2013 - 2014 Aleksander Morgado <aleksander@aleksander.es>
 */


#include <string.h>

#include "mbim-phonebook.h"
#include "mbim-message-private.h"
#include "mbim-enum-types.h"
#include "mbim-error-types.h"
#include "mbim-device.h"
#include "mbim-utils.h"

/*****************************************************************************/
/* Struct: MbimPhonebookEntry */

static void
_mbim_phonebook_entry_free (MbimPhonebookEntry *var)
{
    if (!var)
        return;

    g_free (var->number);
    g_free (var->name);
    g_free (var);
}

/**
 * mbim_phonebook_entry_array_free:
 * @array: a #NULL terminated array of #MbimPhonebookEntry structs.
 *
 * Frees the memory allocated for the array of #MbimPhonebookEntrys.
 */
void
mbim_phonebook_entry_array_free (MbimPhonebookEntry **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_phonebook_entry_free (array[i]);
    g_free (array);
}

static MbimPhonebookEntry *
_mbim_message_read_mbim_phonebook_entry_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimPhonebookEntry *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimPhonebookEntry, 1);

    out->entry_index = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->number = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->name = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimPhonebookEntry **
_mbim_message_read_mbim_phonebook_entry_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimPhonebookEntry **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimPhonebookEntry *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_phonebook_entry_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_phonebook_entry_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static GByteArray *
_mbim_phonebook_entry_struct_new (const MbimPhonebookEntry *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_guint32 (builder, value->entry_index);
    _mbim_struct_builder_append_string (builder, value->number);
    _mbim_struct_builder_append_string (builder, value->name);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_phonebook_entry_struct (
    MbimStructBuilder *builder,
    const MbimPhonebookEntry *value)
{
    GByteArray *raw;

    raw = _mbim_phonebook_entry_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_phonebook_entry_struct (
    MbimMessageCommandBuilder *builder,
    const MbimPhonebookEntry *value)
{
    _mbim_struct_builder_append_mbim_phonebook_entry_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_phonebook_entry_struct_array (
    MbimStructBuilder *builder,
    const MbimPhonebookEntry *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_phonebook_entry_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_phonebook_entry_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_phonebook_entry_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimPhonebookEntry *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_phonebook_entry_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Message (Query): MBIM Message Phonebook Configuration */

/**
 * mbim_message_phonebook_configuration_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Configuration' query command in the 'Phonebook' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_phonebook_configuration_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_PHONEBOOK,
                                                 MBIM_CID_PHONEBOOK_CONFIGURATION,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Phonebook Configuration */

/**
 * mbim_message_phonebook_configuration_response_parse:
 * @message: the #MbimMessage.
 * @state: return location for a #MbimPhonebookState, or %NULL if the 'State' field is not needed.
 * @number_of_entries: return location for a #guint32, or %NULL if the 'NumberOfEntries' field is not needed.
 * @used_entries: return location for a #guint32, or %NULL if the 'UsedEntries' field is not needed.
 * @max_number_length: return location for a #guint32, or %NULL if the 'MaxNumberLength' field is not needed.
 * @max_name: return location for a #guint32, or %NULL if the 'MaxName' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'MaxName' response command in the 'Phonebook' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_phonebook_configuration_response_parse (
    const MbimMessage *message,
    MbimPhonebookState *state,
    guint32 *number_of_entries,
    guint32 *used_entries,
    guint32 *max_number_length,
    guint32 *max_name,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'State' variable */
    {
        if (state != NULL)
            *state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'NumberOfEntries' variable */
    {
        if (number_of_entries != NULL)
            *number_of_entries =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'UsedEntries' variable */
    {
        if (used_entries != NULL)
            *used_entries =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'MaxNumberLength' variable */
    {
        if (max_number_length != NULL)
            *max_number_length =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'MaxName' variable */
    {
        if (max_name != NULL)
            *max_name =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

/*****************************************************************************/
/* Message (Notification): MBIM Message Phonebook Configuration */

/**
 * mbim_message_phonebook_configuration_notification_parse:
 * @message: the #MbimMessage.
 * @state: return location for a #MbimPhonebookState, or %NULL if the 'State' field is not needed.
 * @number_of_entries: return location for a #guint32, or %NULL if the 'NumberOfEntries' field is not needed.
 * @used_entries: return location for a #guint32, or %NULL if the 'UsedEntries' field is not needed.
 * @max_number_length: return location for a #guint32, or %NULL if the 'MaxNumberLength' field is not needed.
 * @max_name: return location for a #guint32, or %NULL if the 'MaxName' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'MaxName' notification command in the 'Phonebook' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_phonebook_configuration_notification_parse (
    const MbimMessage *message,
    MbimPhonebookState *state,
    guint32 *number_of_entries,
    guint32 *used_entries,
    guint32 *max_number_length,
    guint32 *max_name,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_INDICATE_STATUS) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a notification");
        return FALSE;
    }

    /* Read the 'State' variable */
    {
        if (state != NULL)
            *state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'NumberOfEntries' variable */
    {
        if (number_of_entries != NULL)
            *number_of_entries =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'UsedEntries' variable */
    {
        if (used_entries != NULL)
            *used_entries =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'MaxNumberLength' variable */
    {
        if (max_number_length != NULL)
            *max_number_length =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'MaxName' variable */
    {
        if (max_name != NULL)
            *max_name =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

/*****************************************************************************/
/* Message (Query): MBIM Message Phonebook Read */

/**
 * mbim_message_phonebook_read_query_new:
 * @filter_flag: the 'FilterFlag' field, given as a #MbimPhonebookFlag.
 * @filter_message_index: the 'FilterMessageIndex' field, given as a #guint32.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Read' query command in the 'Phonebook' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_phonebook_read_query_new (
    MbimPhonebookFlag filter_flag,
    guint32 filter_message_index,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_PHONEBOOK,
                                                 MBIM_CID_PHONEBOOK_READ,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);
    {
        _mbim_message_command_builder_append_guint32 (builder, filter_flag);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, filter_message_index);
    }

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Phonebook Read */

/**
 * mbim_message_phonebook_read_response_parse:
 * @message: the #MbimMessage.
 * @entry_count: return location for a #guint32, or %NULL if the 'EntryCount' field is not needed.
 * @entries: return location for a newly allocated array of #MbimPhonebookEntrys, or %NULL if the 'Entries' field is not needed. Free the returned value with mbim_phonebook_entry_array_free().
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Entries' response command in the 'Phonebook' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_phonebook_read_response_parse (
    const MbimMessage *message,
    guint32 *entry_count,
    MbimPhonebookEntry ***entries,
    GError **error)
{
    guint32 offset = 0;
    guint32 _entry_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'EntryCount' variable */
    {
        _entry_count = _mbim_message_read_guint32 (message, offset);
        if (entry_count != NULL)
            *entry_count = _entry_count;
        offset += 4;
    }

    /* Read the 'Entries' variable */
    {
        if (entries != NULL)
            *entries = _mbim_message_read_mbim_phonebook_entry_struct_array (message, _entry_count, offset, TRUE);
        offset += (8 * _entry_count);
    }

    return TRUE;
}

/*****************************************************************************/
/* Message (Set): MBIM Message Phonebook Delete */

/**
 * mbim_message_phonebook_delete_set_new:
 * @filter_flag: the 'FilterFlag' field, given as a #MbimPhonebookFlag.
 * @filter_message_index: the 'FilterMessageIndex' field, given as a #guint32.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Delete' set command in the 'Phonebook' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_phonebook_delete_set_new (
    MbimPhonebookFlag filter_flag,
    guint32 filter_message_index,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_PHONEBOOK,
                                                 MBIM_CID_PHONEBOOK_DELETE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, filter_flag);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, filter_message_index);
    }

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Phonebook Delete */

/**
 * mbim_message_phonebook_delete_response_parse:
 * @message: the #MbimMessage.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Delete' response command in the 'Phonebook' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_phonebook_delete_response_parse (
    const MbimMessage *message,
    GError **error)
{

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    return TRUE;
}

/*****************************************************************************/
/* Message (Set): MBIM Message Phonebook Write */

/**
 * mbim_message_phonebook_write_set_new:
 * @save_flag: the 'SaveFlag' field, given as a #MbimPhonebookWriteFlag.
 * @save_index: the 'SaveIndex' field, given as a #guint32.
 * @number: the 'Number' field, given as a string.
 * @name: the 'Name' field, given as a string.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Write' set command in the 'Phonebook' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_phonebook_write_set_new (
    MbimPhonebookWriteFlag save_flag,
    guint32 save_index,
    const gchar *number,
    const gchar *name,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_PHONEBOOK,
                                                 MBIM_CID_PHONEBOOK_WRITE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, save_flag);
    }
    {
        _mbim_message_command_builder_append_guint32 (builder, save_index);
    }
    {
        _mbim_message_command_builder_append_string (builder, number);
    }
    {
        _mbim_message_command_builder_append_string (builder, name);
    }

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Response): MBIM Message Phonebook Write */

/**
 * mbim_message_phonebook_write_response_parse:
 * @message: the #MbimMessage.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Write' response command in the 'Phonebook' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_phonebook_write_response_parse (
    const MbimMessage *message,
    GError **error)
{

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    return TRUE;
}
